/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>



#define VER             "0.1"
#define POP             "\x06\x00\x00\x00" "mb_pop"
#define BUFFSZ          65535
#define READSHOW(x,y)   b2 = *(u_short *)ptr; \
                        if(b2) { \
                            ptr += 4; \
                            if(y) { \
                                pimmy_pwd(ptr, b2); \
                                b2 >>= 2; \
                            } \
                            printf("\n"x); \
                            fwrite(ptr, b2, 1, stdout); \
                            ptr += b2; \
                        }

#ifndef u_char
    #define u_char  unsigned char
#endif
#ifndef u_short
    #define u_short unsigned short
#endif
#ifndef u_int
    #define u_int  unsigned int
#endif



void pimmy_pwd(u_char *buff, int len);
void read_err(void);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE        *fd;
    u_char      *buff,
                *limit,
                *ptr;
    u_short     b2;
    struct stat xstat;


    setbuf(stdout, NULL);

    fputs("\n"
        "Pimmy passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <Pimmy.cfg>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    fstat(fileno(fd), &xstat);
    buff = malloc(xstat.st_size);
    if(!buff) std_err();

    fread(buff, xstat.st_size, 1, fd);
    fclose(fd);

    limit = buff + xstat.st_size;

    for(ptr = buff; ptr < limit; ptr++) {
        if(!memcmp(ptr, POP, sizeof(POP) - 1)) {
            ptr += (sizeof(POP) - 1);
            fputs("\n--------------", stdout);
            READSHOW("E-mail:       ", 0);
            READSHOW("POP Server:   ", 0);
            ptr += 4;
            READSHOW("Username:     ", 0);
            READSHOW("Password:     ", 1);
        }
    }

    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void pimmy_pwd(u_char *buff, int len) {
    u_int  eax,
            ebx,
            ecx,
            esi,
            edi;
    u_short ebp8;
    u_char  ebpc,
            *ptr,
            *pwd;
    int     size,
            tmp;

    ptr = pwd = buff;
    size = len >> 1;
    while(size--) {
        sscanf(pwd, "%02X", &tmp);
        *ptr++ = tmp;
        pwd += 2;
    }

    ptr = pwd = buff;
    size = len >> 4;
    while(size--) {
        ebx = *(u_int *)(pwd + 4);
        esi = ebx >> 0x10;
        ebp8 = (*(u_int *)pwd >> 0x10) | (ebx << 0x10);
        eax = ebx = ecx = 0x18101968;
        edi = (0x18101968 >> 0x10) & 0xff;
        if(esi % edi) break;
        ebx >>= 0x18;
        ebpc = ecx >> 8;
        if(*(u_short *)(pwd + 4) % ebpc) break;
        if((ebp8 & 0xffff) % 0x68) break;
        ecx = *(u_short *)pwd;
        if(ecx % (ebx & 0xff)) break;
        edi = (esi / edi) & 0xff;
        eax = *(u_short *)(pwd + 4) / ebpc;
        edi = (edi << 8) | (eax & 0xff);
        eax = ebp8 / 0x68;
        edi = (edi << 8) | (eax & 0xff);
        eax = ecx / (ebx & 0xff);
        edi = (edi << 8) | (eax & 0xff);
        *(u_int *)ptr = edi;
        ptr += 4;
        pwd += 8;
    }
    *ptr = 0;
}



void read_err(void) {
    fputs("\n"
        "Error: read error, probably the file is corrupted\n"
        "\n"
        "    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


